@echo off

IF EXIST "__backup/JaiInit.aaf" (
  goto FAIL
)

:PACK
mkdir "./__backup"
mkdir "./__backup/Banks"
mkdir "./__backup/Seqs"
copy "./JaiInit.aaf" "./__backup/" > NUL
copy "./Banks" "./__backup/Banks" > NUL
copy "./Seqs" "./__backup/Seqs" > NUL 
echo Unpacking AAF....
echo "%CD%/Banks"
"%CD%/tool/jampacked.exe" unpack JaiInit.aaf Audio_Modding
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/0.wsy" "./Audio_Modding/W_SoundEffects" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/W_SoundEffects/extracted_waves"
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/1.wsy" "./Audio_Modding/W_MainMenu" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/W_MainMenu/extracted_waves"
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/2.wsy" "./Audio_Modding/W_Instruments+Voices" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/W_Instruments+Voices/extracted_waves"
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/3.wsy" "./Audio_Modding/W_Insruments+Ghosts" WS3" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/W_Insruments+Ghosts/extracted_waves"

echo Unpacking IBNK

"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/0.bnk" "./Audio_Modding/IBNK0"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/1.bnk" "./Audio_Modding/IBNK1"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/2.bnk" "./Audio_Modding/IBNK2"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/3.bnk" "./Audio_Modding/IBNK3"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/4.bnk" "./Audio_Modding/IBNK4"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/5.bnk" "./Audio_Modding/IBNK5"

echo Unpacking BST 
"%CD%/tool/bast" unpack "./Audio_Modding/include/0.bst" "./Audio_Modding/SoundTable"

echo Unpacking sequence BARC. 
"%CD%/tool/barctool.exe" unpack "./Audio_Modding/include/1.arc" "./Audio_Modding/Sequences" -arc "./Seqs/"

echo Unpacking sequence system....
"%CD%/tool/bmparse.exe" disassemble "./Audio_Modding/Sequences/0_LuigiSe.bms.bms" "./Audio_Modding/SoundEffectBMS/" -namefile ./tool/luigi.nam

echo Done.
GOTO EOF

:FAIL
echo WARNING: You already have a backup. If you make a backup now, and have made any changes, this will corrupt the backup of your original game files.
echo Choose wisely.

echo Caution: For Super Mario Sunshine and for Luigi's Mansion, doing this without restoring the backup will likely corrupt your sequence arc. 

SET /P AREYOUSURE=No regrets, mister freeman: (Y/[N])
IF /I "%AREYOUSURE%" EQU "Y" GOTO PACK

:EOF
pause